﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using C1.Silverlight;

namespace CheckBoxTreeView_CS
{
    public partial class MainPage : UserControl
    {
        private List<string> selectedItems = new List<string>();
        private List<string> allItems = new List<string>();
        private List<CheckBox> cks = new List<CheckBox>();
        public MainPage()
        {
            InitializeComponent();
            C1TreeView1.ItemsSource = Data.LoadData();
        }

        private void btn_GetAllItems_Click(object sender, RoutedEventArgs e)
        {
            TreeViewItems = new List<Table1>();

            var items = C1TreeView1.Items;
            GetItems(C1TreeView1.Items[0] as Table1);

            string str = "Items Status";

            for (int i = 0; i < TreeViewItems.Count; i++)
            {
                //gets status of all items in C1TreeView whether it is checked or not.
                str += Environment.NewLine + TreeViewItems[i].Name + ":" + TreeViewItems[i].IsChecked.ToString();
            }
            //show message box with item's status
            MessageBox.Show(str);
        }

        private void CheckBox1_Checked(object sender, RoutedEventArgs e)
        {

            CheckBox chkBox = sender as CheckBox;
            (chkBox.DataContext as Table1).IsChecked = true;
            StackPanel stackPanel = chkBox.Parent as StackPanel;
            var parents = stackPanel.GetAllParents();

            selectedItems.Clear();

            for (int i = 0; i < parents.Count; i++)
            {
                if (parents[i].GetType() == typeof(C1TreeViewItem))
                {
                    //adding checked items to selected items list
                    selectedItems.Add(((parents[i] as C1TreeViewItem).DataContext as Table1).Name);
                }
            }

            string row = "Entire Row : " + Environment.NewLine;

            for (int j = selectedItems.Count - 1; j >= 0; j--)
            {
                row += selectedItems[j] + ">";
            }

            row = row.Substring(0, row.LastIndexOf('>'));

            MessageBox.Show(row);
        }

        private void CheckBox1_Unchecked(object sender, RoutedEventArgs e)
        {
            CheckBox chkBox = sender as CheckBox;
            (chkBox.DataContext as Table1).IsChecked = false;   
        }
        List<Table1> TreeViewItems;

        public void GetItems(Table1 table)
        {
            TreeViewItems.Add(table);
            if (table.Children != null)
            {
                for (int i = 0; i < table.Children.Count; i++)
                {
                    GetItems(table.Children[i]);
                }
            }
        }
    }
    public class Table1 : INotifyPropertyChanged, IEditableObject
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private string _name;
        private string _previousName;
        private bool _isChecked;

        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Name"));
                }
            }
        }

        public bool IsChecked
        {
            get
            {
                return _isChecked;
            }
            set
            {
                _isChecked = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("IsChecked"));
                }
            }
        }

        public List<Table1> Children { get; set; }

        public void BeginEdit()
        {
            _previousName = Name;
        }

        public void CancelEdit()
        {
            Name = _previousName;
        }

        public void EndEdit()
        {
            _previousName = null;
        }
    }

}
